
      SUBROUTINE D3SOLV(N, DA, UA, LA, B, X)
C
C
C      Written by Daniel Gaude-Fugarolas in February 2000
C
C     Solves tri-diagonal simultaneous linear equation systems AX=B
C
C     Main diagonal...DA(1-n)  Upper/Lower...UA(1-(n-1))/LA(2-n)
C
C     In two steps, first prepares matrices, and then solves.
C
C     ...dummie arguments...
C
      INTEGER N
      DOUBLE PRECISION DA(N), UA(N), LA(N), B(N), X(N)
C
C     ...Local arguments...
C
      INTEGER I
      DOUBLE PRECISION TEMP
C
C     ...Routine starts...
C     ...First modifies matrices...
C
      TEMP = DA(1)
      B(1) = B(1) / TEMP
      UA(1) = UA(1) / TEMP
C
      DO 11, I=2, (N-1)
           TEMP = DA(I) - LA(I)*UA(I-1)
           B(I) = B(I) - B(I-1)*LA(I)
           UA(I) = UA(I) / TEMP
           B(I) = B(I) / TEMP
C
  11  CONTINUE
C
      TEMP = DA(N) - LA(N)*UA(N-1)
      B(N) = B(N) - B(N-1)*LA(N)
      B(N) = B(N) / TEMP
C
C
C     ...Now solves the system...
C          ...from N to 1...
C
      X(N) = B(N)
      DO 21, I=(N-1), 1, -1
           X(I) = B(I) - UA(I)*X(I+1)
  21  CONTINUE
C
C     ...End of the routine...
C
      RETURN
      END
C
